C	----------------------------------------------------------------
C       PROGRAM TO CALCULATE THE STRUCTURE FACTOR FOR DOAMOND STRUCTURES
C	----------------------------------------------------------------
	DIMENSION TITLE(20),J(100),K(100),L(100),IO(100),S2THE(100),ST
     *  HE(100),ALP(100),THE(100),SITE(100),AICAL(100),FCAL(100),SCAT(1
     *  0),COS2T(100),SIN2T(100),UF(100),FO(100),A(5,5),B(5,5),DIS1(5),D
     *	IS2(5),UI(100),C(5),FO1(5),AIOBS(100),AIO(100)
	OPEN(2,FILE='SF_IN')
	OPEN(4,FILE='SF_OUT')
	OPEN(8,FILE='SI_OUT')
	READ(2,11)(TITLE(I),I=1,20)
	WRITE(4,11)(TITLE(I),I=1,20)
	WRITE(6,11)(TITLE(I),I=1,20)
 11	FORMAT(20A4)
	READ(2,*)ALMDA,CELL,JPARA,XFRAC,YFRAC
	WRITE(4,21)ALMDA,CELL,JPARA,XFRAC,YFRAC
	WRITE(6,21)ALMDA,CELL,JPARA,XFRAC,YFRAC
 21	FORMAT(2F8.4,I2,2F8.4)
	READ(2,*)N
	WRITE(4,31)N
	WRITE(6,31)N
 31	FORMAT(I2)
	DO 70 JJ=1,JPARA
	READ(2,*)(A(JJ,I),I=1,5),(B(JJ,I),I=1,5),C(JJ)
	WRITE(4,61)(A(JJ,I),I=1,5),(B(JJ,I),I=1,5),C(JJ)
	WRITE(6,61)(A(JJ,I),I=1,5),(B(JJ,I),I=1,5),C(JJ)
 61	FORMAT(9F8.4)
	READ(2,*)DIS1(JJ),DIS2(JJ)
	WRITE(4,71)DIS1(JJ),DIS2(JJ)
	WRITE(6,71)DIS1(JJ),DIS2(JJ)
 71	FORMAT(2F8.4)
70	CONTINUE
	READ(2,*)(J(I),K(I),L(I),AIOBS(I),I=1,N)	
 	WRITE(4,81)(J(I),K(I),L(I),AIOBS(I),I=1,N)
 	WRITE(6,81)(J(I),K(I),L(I),AIOBS(I),I=1,N)
 81	FORMAT(3I3,F8.2)
	WRITE(4,51)
51	FORMAT('--------------------------------------------------------
     *------------------')
	WRITE(4,49)                           
49	FORMAT('  H  K  L  THETA      (SIN0/\)    FO      FC        M     
     *  LP     LN(FO/FC)')
	WRITE(4,52)
52	FORMAT('--------------------------------------------------------
     *------------------')
	WRITE(6,53)
53	FORMAT('--------------------------------------------------------
     *------------------')
	WRITE(8,59)                           
59	FORMAT('  H  K  L  THETA      (SIN0/\)    IO      IC        M     
     *  LP     LN(IO/IC)')
	WRITE(8,55)
55	FORMAT('--------------------------------------------------------
     *------------------')
	DO 100 I=1,N
	S2THE(I)=(J(I)**2+K(I)**2+L(I)**2)/(4.0*(CELL**2))
	STHE(I)=SQRT(S2THE(I))
	SITE(I)=S2THE(I)*(ALMDA**2)
	THE(I)=ATAN(SQRT(SITE(I)/(1.-SITE(I))))*57.295779
C	----------------------------
C	STRUCTURE FACTOR CALCULATION
C	----------------------------
	DO 112 JJ =1,JPARA
	SF=0.0
	DO 102 M=1,5
	SRF=A(JJ,M)*EXP(-B(JJ,M)*S2THE(I))
102     SF=SF+SRF
	SF=SQRT((SF+C(JJ)+DIS1(JJ))**2+DIS2(JJ)**2)
112	FO1(JJ)=SF
	WRITE(6,*)FO1(1),FO1(2),FO1(3)
	F1=FO1(1)*XFRAC+FO1(3)*(1.-XFRAC)
        F2=FO1(2)*YFRAC+FO1(4)*(1.-YFRAC)
	IS=J(I)/J(I)
	IF(IS*J(I)/2*2-J(I))30,40,30
30	FCAL(I)=ABS(4.0*(F1-F2))
	GO TO 240
40	FCAL(I)=4.*(F1+F2)
240	AICAL(I)=FCAL(I)**2
C	-------------------------
C	OBSERVED STRUCTURE FACTOR
C	-------------------------
C	LP CORRECTION FOR POWDER
C	-------------------------
	TT=THE(I)/57.295779
	T1=2.*TT
	COS2T(I)=COS(T1)**2
	SIN2T(I)=SIN(TT)**2
	ALP(I)=(1+COS2T(I))/(SIN2T(I)*COS(TT))
C	-------------------
C	MULTIPLICITY FACTOR
C	-------------------
	LL=J(I)*K(I)*L(I)
	IF(LL.EQ.0)GO TO 222
	IF(J(I).EQ.K(I).AND.K(I).EQ.L(I))GO TO 111
	CONTINUE
	IF(J(I).NE.K(I).AND.K(I).NE.L(I))GO TO 116
	CONTINUE
 	IF(J(I).EQ.K(I))GO TO 24
	IF(K(I).EQ.L(I))GO TO 24
	IF(L(I).EQ.J(I))GO TO 24
	CONTINUE
222	IF(J(I).NE.0.AND.K(I).EQ.0.AND.L(I).EQ.0)GO TO 25
	IF(K(I).NE.0.AND.L(I).EQ.0.AND.J(I).EQ.0)GO TO 25
	IF(L(I).NE.0.AND.J(I).EQ.0.AND.K(I).EQ.0)GO TO 25
	CONTINUE
	IF(J(I).EQ.K(I).AND.L(I).EQ.0)GO TO 26
	IF(K(I).EQ.L(I).AND.J(I).EQ.0)GO TO 26
	IF(L(I).EQ.J(I).AND.K(I).EQ.0)GO TO 26
	CONTINUE
	IF(J(I).NE.K(I).AND.L(I).EQ.0)GO TO 27
	IF(K(I).NE.L(I).AND.J(I).EQ.0)GO TO 27
	IF(L(I).NE.J(I).AND.K(I).EQ.0)GO TO 27
27	M=24
	GO TO 220
26	M=12
	GO TO 220
25	M=6
	GO TO 220
24	M=24
	GO TO 220
116	M=48
	GO TO 220
111	M=8
	GO TO 220
220	FO(I)=SQRT(AIOBS(I)/(M*ALP(I)))
	AIO(I)=FO(I)**2
	UF(I)=ALOG(FO(I)/FCAL(I))
	UI(I)=ALOG(AIO(I)/AICAL(I))
	WRITE(4,48)J(I),K(I),L(I),THE(I),S2THE(I),FO(I),FCAL(I),M,ALP(I)
     *	,UF(I)
	WRITE(6,*)J(I),K(I),L(I),THE(I),S2THE(I),FO(I),FCAL(I),M,ALP(I)
     *	,UF(I)
48    FORMAT(3I3,2X,F8.5,2X,F8.5,2X,F8.3,2X,F8.3,2X,I2,2X,F8.4,2X,F8.5)
	WRITE(8,50)J(I),K(I),L(I),THE(I),S2THE(I),AIO(I),AICAL(I),M,ALP(
     *	I),UI(I)
50    FORMAT(3I3,2X,F8.5,2X,F8.5,2X,F8.3,2X,F8.3,2X,I2,2X,F8.4,2X,F8.5)
 100	CONTINUE
    	STOP
	END
